require({cache:{
'url:epi-ecf-ui/contentediting/editors/templates/SaleCodeEditor.html':"﻿<div class=\"epi-saleCodeEditor\">\r\n    <div data-dojo-type=\"dijit/form/TextBox\" data-dojo-attach-point=\"textWidget\" data-dojo-attach-event=\"onKeyDown: _handleKey\"></div>\r\n    <div data-dojo-type=\"epi-cms/contentediting/editors/SelectionEditor\" data-dojo-attach-point=\"selectWidget\" data-dojo-attach-event=\"onKeyDown: _handleKey\"></div>\r\n</div>\r\n"}});
﻿define("epi-ecf-ui/contentediting/editors/SaleCodeEditor", [
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/_base/array",
    "dojo/dom-style",
    "dojo/keys",
// dijit
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/form/TextBox",
    "dijit/focus",
// dojox
    "dojox/html/entities",
// cms
    "epi-cms/contentediting/editors/SelectionEditor",
// template
    "dojo/text!./templates/SaleCodeEditor.html"
], function (
// dojo
    declare,
    lang,
    array,
    domStyle,
    keys,
// dijit
    _Widget,
    _TemplatedMixin,
    _WidgetsInTemplateMixin,
    TextBox,
    focusUtil,
// dojox
    htmlEntities,
// CMS
    SelectionEditor,
// template
    template
) {

    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin], {
        // module:
        //  epi-ecf-ui/contentediting/editors/SaleCodeEditor
        // summary:
        //    Represents the widget to edit sale codes.
        // tags:
        //    public

        templateString: template,

        shouldShowDropDown: false,

        startup: function () {
            this.showDropDown(this.get("shouldShowDropDown"));
        },

        showDropDown: function (showDropDown) {
            this.set("shouldShowDropDown", showDropDown);
            domStyle.set(this.selectWidget.domNode, "display", showDropDown ? "" : "none");
            domStyle.set(this.textWidget.domNode, "display", showDropDown ? "none" : "");
        },

        _getValueAttr: function () {
            return this._getActiveWidget().get("value");
        },

        _setValueAttr: function(value){
            this.selectWidget.set("value", value);
            this.textWidget.set("value", value);
        },

        _getActiveWidget: function(){
            return this.get("shouldShowDropDown") ? this.selectWidget : this.textWidget;
        },

        _setSelectionsAttr: function (selections) {
            //TODO: this can be removed when bug 115958 is fixed
            var clonedSelections = lang.clone(selections);
            //Encode the values before setting to the dropdown list
            array.forEach(clonedSelections, function (selection, i) {
                clonedSelections[i].text = htmlEntities.encode(selection.text);
            });
            this.selectWidget.set("selections", clonedSelections);
        },

        _handleKey: function (e) {
            if(e.keyCode === keys.ENTER){
                e.preventDefault();
                focusUtil.curNode.blur();
            }
        },

        focus: function(){
            this._getActiveWidget().focus();
        }
    });
});
